

#    MIDAS Access Client  for the  DataAcquisitionControl service

global env
source [file join $env(MIDASBASE) SOAP tcl MIDASAccessClient.tcl]    ;#   load default support procedures

global DataAcquisitionControlServerHost DataAcquisitionControlServerPort
global SOAPServerHost SOAPServerPort

if {[info exists DataAcquisitionControlServerHost] == 0} then {set DataAcquisitionControlServerHost $SOAPServerHost}
if {[info exists DataAcquisitionControlServerPort] == 0} then {set DataAcquisitionControlServerPort $SOAPServerPort}

variable uri "urn:DataAcquisitionControlServer"
variable proxy "http://$DataAcquisitionControlServerHost:$DataAcquisitionControlServerPort/DataAcquisitionControlServer"

set DataAcquisitionControlClient__TimeOut 10000


SOAP::create DataAcquisitionControlClient__GetState -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name GetState \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request 

SOAP::create DataAcquisitionControlClient__GetLastError -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name GetLastError \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request 

SOAP::create DataAcquisitionControlClient__GetInformation -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name GetInformation \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request

SOAP::create DataAcquisitionControlClient__DoReset -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name DoReset \
     -params {Parameter string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataAcquisitionControlClient__DoSetUp -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name DoSetUp \
     -params {Parameter string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataAcquisitionControlClient__DoStop -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name DoStop \
     -params {Parameter string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataAcquisitionControlClient__DoGo -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name DoGo \
     -params {Parameter string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataAcquisitionControlClient__DoOption -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name DoOption \
     -params {Parameter string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataAcquisitionControlClient__GetOption -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name GetOption \
     -params {Parameter string} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply

SOAP::create DataAcquisitionControlClient__GetCounters -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name GetCounters \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request 

SOAP::create DataAcquisitionControlClient__GetRates -proxy $proxy -uri $uri -timeout $DataAcquisitionControlClient__TimeOut \
     -name GetRates \
     -params {} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request

SOAP::create DataAcquisitionControlClient__ServerVerbose -proxy $proxy -uri $uri -timeout 1000 \
     -name ServerVerbose \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 

SOAP::create DataAcquisitionControlClient__ServerImplementation -proxy $proxy -uri $uri -timeout 1000 \
     -name ServerImplementation \
     -params {opt int} \
     -wrapProc  ::SOAP::MIDAS_SOAPAccessClient_Request \
     -parseProc ::SOAP::MIDAS_SOAPAccessClient_Reply 




package provide DataAcquisitionControlClient 1.0
