




#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

    variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click

 #   get_pulser     ;#  update values

}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable JS ""

    variable AttenuationList
    variable FrequencyList
    variable ModeList
    variable Attenuation
    variable Frequency
    variable Mode
    variable Enable
    variable CFD
    variable Pulser

    variable PreAmpDAC 0

    set AttenuationList { \
       "40 dB"  \
       "30 dB"  \
       "20 dB"  \
       "10 dB"  \
       "none"   \
    }

    set FrequencyList {  \
       "100 Hz"   \
       "200 Hz"   \
       "400 Hz"   \
       "800 Hz"   \
       "1600 Hz"   \
       "3200 Hz"   \
       "6400 Hz"   \
       "SYNC pulse"  \
    }

    set ModeList { \
       "rectangular"  \
       "exponential"  \
    }

    set Attenuation [lindex $AttenuationList 0]
    set Frequency [lindex $FrequencyList 0]
    set Mode [lindex $ModeList 0]

    set Enable 0
    set CFD 0
    set Pulser 0

    source Global.tcl

    proc get_pulser_register {addr}  {
        global errorCode errorInfo
        variable ::AGATADigitizer::Digitizer

        set fpga 2   ;# Virtex for core ADCs
        set Addr $addr

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Get $Digitizer $fpga $Addr A16} m]
        if {$rc != 0} {
            InsertLog "Get returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
    }

    proc set_pulser_register {addr Vl}  {
        global errorCode errorInfo
        variable ::AGATADigitizer::Digitizer 

        set fpga 2   ;# Virtex for core ADCs
        set Addr $addr

        set rc [catch {interp eval "" ::namespace inscope ::urn:AGATADigitizerAccessServer do_Set $Digitizer $fpga $Addr A16 1 $Vl} m]
        if {$rc != 0} {
            InsertLog "Set returned with an error\n$m\n$errorCode\n$errorInfo"
            return -1
        } else {
            return $m
        }
    }

    proc set_pulser {W} {
       variable Attenuation
       variable Frequency
       variable Mode
       variable Enable
       variable CFD
       variable Pulser
       variable PreAmpDAC

       variable AttenuationList
       variable FrequencyList
       variable ModeList

     if {$W == "CTRL"} {

#    Set Pulser Control Register (Offset 14)

       set attenuation [lindex [list 0 8 12 14 15] [lsearch $AttenuationList $Attenuation]]
       set frequency [lindex [list 0 1 2 3 4 5 6 7] [lsearch $FrequencyList $Frequency]]
       set mode [lindex [list 0 1] [lsearch $ModeList $Mode]]

        set Value  [expr (((((((((($frequency << 1) + $Enable) << 1) + $CFD) << 2) + $Pulser) << 1) + $mode) << 7) + $attenuation )]
        set Addr 14
     }

     if {$W == "DAC"} {

#    Set Pulser DAC (Offset 15)

        set Value  $PreAmpDAC
        set Addr 15
     }

        InsertLog "Setting Pulser Control ([set Addr]) = $Value [format "0x%x" [set Value]]"

        set rc [set_pulser_register $Addr $Value]

    }

    proc get_pulser {} {
       variable Attenuation
       variable Frequency
       variable Mode
       variable Enable
       variable CFD
       variable Pulser
       variable PreAmpDAC
       variable JS

       variable AttenuationList
       variable FrequencyList
       variable ModeList

        set R14 [get_pulser_register 14]
        if {$R14 == -1} {return}         ;# read error

        set R15 [get_pulser_register 15]
        if {$R15 == -1} {return}         ;# read error

        set PreAmpDAC  $R15
        set attenuation  [expr $R14 & 15]
        set mode [expr ($R14 >> 7) & 1]
        set Pulser [expr ($R14 >> 8) & 1]
        set CFD [expr ($R14 >> 10) & 1]
        set Enable [expr ($R14 >> 11) & 1]
        set frequency [expr ($R14 >> 12) & 7]

        if {[lsearch [list 0 8 12 14 15] $attenuation] == -1} {
           append JS "alert(\"Bad value returned: Offset 14=0x[format "%x" $R14]\");"
           set Attenuation [lindex $AttenuationList 0]
        } else {
           set Attenuation [lindex $AttenuationList [lsearch [list 0 8 12 14 15] $attenuation]]
        }

        if {[lsearch [list 0 1 2 3 4 5 6 7] $frequency] == -1} {
           append JS "alert(\"Bad value returned: Offset 14=0x[format "%x" $R14]\");"
           set Frequency [lindex $FrequencyList 0]
        } else {
            set Frequency [lindex $FrequencyList [lsearch [list 0 1 2 3 4 5 6 7] $frequency]]
        }

        set Mode [lindex $ModeList $mode]

    }

    proc do_parameters {} {
        variable cgidata

        if {[llength [lindex $cgidata 1]] == 2} {   ;# checkbox 
            set name [first [lindex $cgidata 1]]
            set value [second [lindex $cgidata 1]]

            variable $name
            set $name $value
            InsertLog "$name = $value"
      
            return 1
        }

        for {set i 2} {$i < [llength $cgidata]} {incr i} {

            set name [lindex $cgidata $i]
            incr i
            set value [lindex $cgidata $i]

            switch -glob $name {

               Offset1_value {
                   variable PreAmpDAC
                   set PreAmpDAC $value
                   InsertLog "PreAmpDAC = $value"
               }

               Attenuation -
               Frequency -
               Mode  {
                    variable $name
                    set $name $value
                    InsertLog "$name = $value"
               }
            }
        }

        return 0
   }

   proc  show_variables {} {
       variable LogText
       variable ShowLogFlag
       variable JS
       variable Attenuation
       variable Frequency
       variable Mode
       variable Enable
       variable CFD
       variable Pulser
       variable PreAmpDAC

         if {$ShowLogFlag == 1} {
             set LogText ""
             InsertLog "Attenuation=$Attenuation; Frequency=$Frequency; Mode=$Mode; Enable=$Enable; CFD=$CFD; Pulser=$Pulser; PreAmpDAC=$PreAmpDAC"
         }  else {
             append JS "alert(\"Attenuation=$Attenuation; Frequency=$Frequency; Mode=$Mode; Enable=$Enable; CFD=$CFD; Pulser=$Pulser; PreAmpDAC=$PreAmpDAC\");"
         }
   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

      set cgidata [ncgi::nvlist]

     if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

      if {[llength $cgidata] == 0} then {return}

      if {[llength $cgidata] < 2} then {
         InsertLog "CGI data is too short: $cgidata"
      } else {
        if {[lindex $cgidata 0] != "Widget"} then {
            InsertLog "Invalid CGI data: $cgidata"
        } else {

           if {[do_parameters] != 0} {return}

           switch -glob [lindex $cgidata 1] {

                RESET    {set started 0}
                CLEAR    {EmptyLog}
                ELOG     {PrintLog}
                SELECT   {}
                RELOAD   {get_pulser}
                VARIABLES {show_variables}

                HIDE     {set ShowLogFlag 0}
                SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                PARAM     {}

                PULSER    {set_pulser CTRL; get_pulser}
                PREAMPDAC {set_pulser DAC; get_pulser}

                MainLog {}
                undefined {}
                default  {InsertLog "unexpected cgi data:  $cgidata"}
            }
         }
       }
    }

    get_pulser

}  ;# end of if {$started == 0}



